"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const loggers = [];
class Logger {
    constructor(name) {
        this.name = name;
        if (process.env.LOGGERS) {
            this.display = parseInt(process.env.LOGGERS) ? true : false;
        }
        else {
            this.display = true;
        }
        loggers.push(this);
    }
    log(message) {
        if (this.display)
            console.info(`[\x1b[36m${this.name}\x1b[0m]`, message);
    }
    info(message) {
        if (this.display)
            console.info(`[\x1b[36m${this.name}\x1b[0m]`, `\x1b[34m${message}\x1b[0m`);
    }
    error(message) {
        if (this.display)
            console.info(`[\x1b[36m${this.name}\x1b[0m]`, `\x1b[31m${message}\x1b[0m`);
    }
    success(message) {
        if (this.display)
            console.info(`[\x1b[36m${this.name}\x1b[0m]`, `\x1b[32m${message}\x1b[0m`);
    }
    setdisplay(display = false) {
        this.display = display;
    }
}
exports.Logger = Logger;
function displayAllLoggers(display = true) {
    for (const l of loggers) {
        l.setdisplay(display);
    }
}
exports.displayAllLoggers = displayAllLoggers;
//# sourceMappingURL=logging.js.map