"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const vcms_1 = require("../vcms");
class User extends vcms_1.CreamModel {
    /* helpers */
    verifyExistence() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.id) {
                return false;
            }
            const user = yield User.get(this.id);
            return (user ? true : false);
        });
    }
    hasRole(role) {
        return __awaiter(this, void 0, void 0, function* () {
            let r;
            for (r of this.roles) {
                if (typeof r === 'string' && r === role) {
                    return true;
                }
                if (typeof r === 'object' && r.name === role) {
                    return true;
                }
            }
            return false;
        });
    }
}
User.tableName = 'users';
User.relationMappings = {
    roles: {
        relation: vcms_1.CreamModel.ManyToManyRelation,
        modelClass: `${__dirname}/Role`,
        join: { from: 'users.id', through: { from: 'users_roles.user_id', to: 'users_roles.role_id' }, to: 'roles.id' }
    }
};
User.jsonSchema = {
    type: 'object',
    required: ['username', 'firstname', 'lastname', 'email', 'password'],
    properties: {
        id: { type: 'integer' },
        username: { type: 'string' },
        firstname: { type: 'string' },
        lastname: { type: 'string' },
        email: { type: 'string' },
        password: { type: 'string' }
    }
};
/* getters */
User.get = (id, eager = '') => __awaiter(this, void 0, void 0, function* () {
    return (yield User.query().where('id', id).eager(eager))[0];
});
User.getByUsername = (username, eager = '') => __awaiter(this, void 0, void 0, function* () {
    return (yield User.query().where('username', username).eager(eager))[0];
});
exports.default = User;
//# sourceMappingURL=User.js.map