/// <reference types="node" />
/// <reference types="knex" />
/// <reference types="express" />
import { Application } from 'express';
import * as Knex from 'knex';
import { Server } from 'net';
import { VcmsOptions } from './config';
import { Session } from './session';
export interface Structure {
    server: Server;
    database: Knex;
    Session: Session;
    app: Application;
    config?: VcmsOptions;
}
export declare function getStructure(config: VcmsOptions): Promise<Structure>;
export declare function destroyStructure(structure: Structure): Promise<void>;
export declare function getServer(config: VcmsOptions, app: Application): Promise<Server>;
/**
 * @param {string} startupFilepath entrypoint configuration script path.
 *    This script lets you define all the dynamic configuration of your
 *    application, e.g. the routers, the middlewares, the path to a static
 *    configuration file, ...
 */
export declare function startServer(startupFilepath?: string): Promise<void>;
